package blake2

import (
	// Standard
	"encoding/hex"

	// Standard Extended
	"golang.org/x/crypto/blake2b"
)

// Hash
func (algorithm Algorithm) Hash(data []byte) (string, error) {
	// Hasher
	hasher, err := blake2b.New(algorithm.size, nil)
	// Handle Error
	if err != nil {
		return "", err
	}
	// Write To Hasher
	_, err = hasher.Write(data)
	// Handle Error
	if err != nil {
		return "", err
	}
	// Return Hash
	return hex.EncodeToString(hasher.Sum(nil)), err
}
